<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class>
      <h1>Accounts</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->

      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }">
          <i class="mdi mdi-home-outline"></i>
        </el-breadcrumb-item>
        <el-breadcrumb-item>Accounts</el-breadcrumb-item>
      </el-breadcrumb>

      <div style="text-align: right; position: relative">
        <el-button
          type="primary"
          style="position: absolute; top: -30px; right: 0"
          class=""
          @click="dialogFormvisible = true"
        >
          <i class="mdi mdi-plus"> </i>
          <span> Add</span>
        </el-button>
      </div>
      <add-account
        :dialogFormvisible.sync="dialogFormvisible"
        rerefreshList
      ></add-account>
    </div>
    <br />
    <el-card
      class="box-card"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    >
      <div class="card-header">
      </div>
      <el-table
        id="style-3"
        rowClassName="pointer-row"
        @row-click="showDetail"
        :data="list"
      >
        <el-table-column
          fixed
          prop="id"
          label="ID"
          width="100"
        ></el-table-column>
        <el-table-column
          min-width="150"
          prop="name"
          label="Name"
        ></el-table-column>
        <el-table-column
          min-width="250"
          prop="username"
          label="Email"
        ></el-table-column>
        <el-table-column
          min-width="250"
          prop="role_id"
          label="Role"
        >
          <template slot-scope="scope">
            <el-tag
              style="min-width: 90px;text-align:center;"
              size="small"
              v-for="role in scope.row.roles"
              :key="role.id"
            >
              {{role.name}}
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column
          min-width="250"
          prop="created_at"
          label="Created At"
        ></el-table-column>

      </el-table>
      <div
        class="flex justify-space-between"
        style="align-items:center;"
      >
        <span>Total accounts: {{total}}</span>
        <!-- <el-pagination
                        v-if="total > pageSize"
                        class="right"
                        background
                        layout="prev, pager, next"
                        :current-page="currentPage"
                        :page-size="pageSize"
                        @current-change="onChangePage"
                        :total="total"
                ></el-pagination> -->
      </div>
    </el-card>

  </div>
</template>

<script>
import AddAccount from "~/components/dialogs/AddAccount";
import { account as accountApi } from "~/services/apis/index";

export default {
  name: "Account",
  data () {
    return {
      list: [],
      imageUrl: null,
      pageWidth: 0,
      userdata: {},
      loading: true,
      dialogFormvisible: false,
      total: '',
    };
  },
  components: {
    AddAccount,
  },

  watch: {
    onSubmit () {
      this.onSearch();
    },
    "$route.query" () {
      this.getListData();
    }
  },
  methods: {
    openDialog (data) {
      this.userdata = data;
      this.dialogFormvisible = true;
    },
    __resizeHanlder: _.throttle(function (e) {
      //this.setPageWidth()
    }, 700),
    getListData () {
      this.loading = true;
      accountApi
        .getAccounts(this.currentPage,
          this.pageSize,
          this.sortBy,
          this.dir)
        .then(res => {
          /*eslint-disable*/
          // console.log('res.data.data :', res.data.data);
          this.list = res.data.data;
          this.loading = false;
          this.total = parseInt(res.headers["x-total-count"]);
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot get data from server!",
            type: "error"
          });
          this.loading = false
          this.not_found = true
        })
    },
    showDetail (row) {
      var selection = window.getSelection();
      if (selection.toString().length !== 0) return;
      var id = row.id;
      this.$router.push({ name: "account_detail", params: { id } });
    },



    onRemove (id, event) {
      // this.loading = true;
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      this.$confirm('Are you sure you want to delete this account?', 'Warning', {
        confirmButtonText: 'Yes',
        cancelButtonText: 'Cancel',
        type: 'warning',
        center: true
      }).then(() => {
        accountApi.removeAccount(id)
          .then((res) => {
            if (res.status === 204) {
              this.$notify({
                title: 'Success',
                message: 'Delete account successfully!',
                type: 'success'
              });

              this.loading = false;
              this.getListData();
            }
          })
          .catch(() => {
            this.$notify.error({
              title: 'Error',
              message: 'Cannot delete account'
            });
            this.loading = false;
          })
      }).catch((err) => {
        this.loading = false;
      });

    },

    onEdit (id, event) {
      event.preventDefault();
      event.stopPropagation();
      this.$router.push({ name: "accounts_detail", params: { id } });
    },


  },
  mounted () {
    this.getListData();
  }
};
</script>

<style lang="scss" scoped>
@import "../../../assets/scss/_variables";
.z-index-999 {
  z-index: 999;
}
.btn-eye {
  padding: 1px 6px;
}
.btn-action {
  padding: 6px;
  margin-right: 10px;
}
.btn-blue {
  width: 120px;
  color: rgb(95, 143, 223);
}
.btn-red {
  color: red;
}
// .el-table thead {
//     color: #666 !important;
// }
</style>

